package syscon.arbutus.product.services.legal.contract.dto.ordersentence;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * AggregateSentenceGroupType -- Aggregate Level's sentences. Generated by Sentence Calculation Engine.
 * <p>Not able to be updated or deleted, therefore, there is no 'REQUIRED/OPTIONAL' defined in this type.
 *
 * @author yshang
 * @since Jan. 07, 2014
 */
public class AggregateSentenceGroupType implements Serializable {

    private static final long serialVersionUID = -6307064087321660112L;
    /**
     * aggregateSentences List of aggregated sentences
     */
    List<AggregateSentenceType> aggregateSentences;
    /**
     * aggregateGroupId Identification of AggregateSentenceGroupType. System generated
     */
    private Long aggregateGroupId;
    /**
     * supervisionId Supervision Id
     */
    private Long supervisionId;
    /**
     * startDate Sentence Start Date
     */
    private Date startDate;
    /**
     * endDate Sentence End Date
     */
    private Date endDate;
    /**
     * prdDate Probable release date
     */
    private Date prdDate;
    /**
     * totalSentenceDays Total sentence days
     */
    private Long totalSentenceDays;
    /**
     * goodTime Good Time -- Sentence adjustment type: GT(Good Time)
     */
    private Long goodTime;
    /**
     * daysToServe Days to serve
     */
    private Long daysToServe;
    /**
     * staffId Staff Id
     */
    private Long staffId;
    /**
     * comments Comment
     */
    private String comment;
    /**
     * calculatingDate The date of the staff calculated
     */
    private Date calculatingDate;
    /**
     * isControlling Is Controlling Aggregated Sentence --  True: is; False: is not
     */
    private Boolean isControlling;

    /**
     * sentenceKeyDateHistId Id of Sentence Key Date history
     */
    private Long sentenceKeyDateHistId;

    /**
     * supervisionSentenceId Id of Supervision Sentence Type
     */
    private Long supervisionSentenceId;

    /**
     * Constructor
     */
    public AggregateSentenceGroupType() {
        super();
    }

    /**
     * getAggregateGroupId
     * <p>Identification of AggregateSentenceGroupType. System generated
     *
     * @return the aggregateGroupId
     */
    public Long getAggregateGroupId() {
        return aggregateGroupId;
    }

    /**
     * setAggregateGroupId
     * <p>Identification of AggregateSentenceGroupType. System generated
     *
     * @param aggregateGroupId the aggregateGroupId to set
     */
    public void setAggregateGroupId(Long aggregateGroupId) {
        this.aggregateGroupId = aggregateGroupId;
    }

    /**
     * getSupervisionId
     * <p>Supervision Id
     *
     * @return the supervisionId
     */
    public Long getSupervisionId() {
        return supervisionId;
    }

    /**
     * setSupervisionId
     * <p>Supervision Id
     *
     * @param supervisionId the supervisionId to set
     */
    public void setSupervisionId(Long supervisionId) {
        this.supervisionId = supervisionId;
    }

    /**
     * getStartDate
     * <p>Sentence Start Date
     *
     * @return the startDate
     */
    public Date getStartDate() {
        return startDate;
    }

    /**
     * setStartDate
     * <p>Sentence Start Date
     *
     * @param startDate the startDate to set
     */
    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    /**
     * getEndDate
     * <p>Sentence End Date
     *
     * @return the endDate
     */
    public Date getEndDate() {
        return endDate;
    }

    /**
     * setEndDate
     * <p>Sentence End Date
     *
     * @param endDate the endDate to set
     */
    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

    /**
     * getPrdDate
     * <p>Probable release date
     *
     * @return the prdDate
     */
    public Date getPrdDate() {
        return prdDate;
    }

    /**
     * setPrdDate
     * <p>Probable release date
     *
     * @param prdDate the prdDate to set
     */
    public void setPrdDate(Date prdDate) {
        this.prdDate = prdDate;
    }

    /**
     * getTotalSentenceDays
     * <p>Total sentence days
     *
     * @return the totalSentenceDays
     */
    public Long getTotalSentenceDays() {
        return totalSentenceDays;
    }

    /**
     * setTotalSentenceDays
     * <p>Total sentence days
     *
     * @param totalSentenceDays the totalSentenceDays to set
     */
    public void setTotalSentenceDays(Long totalSentenceDays) {
        this.totalSentenceDays = totalSentenceDays;
    }

    /**
     * getGoodTime
     * <p>Sentence adjustment type: GT(Good Time)
     *
     * @return the goodTime
     */
    public Long getGoodTime() {
        return goodTime;
    }

    /**
     * setGoodTime
     * <p>Sentence adjustment type: GT(Good Time)
     *
     * @param goodTime the goodTime to set
     */
    public void setGoodTime(Long goodTime) {
        this.goodTime = goodTime;
    }

    /**
     * getDaysToServe
     * <p>Days left to serve
     *
     * @return the daysToServe
     */
    public Long getDaysToServe() {
        return daysToServe;
    }

    /**
     * setDaysToServe
     * <p>Days left to serve
     *
     * @param daysToServe the daysToServe to set
     */
    public void setDaysToServe(Long daysToServe) {
        this.daysToServe = daysToServe;
    }

    /**
     * getStaffId
     * <p>Staff Id
     *
     * @return the staffId
     */
    public Long getStaffId() {
        return staffId;
    }

    /**
     * setStaffId
     * <p>Staff Id
     *
     * @param staffId the staffId to set
     */
    public void setStaffId(Long staffId) {
        this.staffId = staffId;
    }

    /**
     * getComment
     * <p>Comment inputed by staff when create/update sentence key date
     *
     * @return the comment
     */
    public String getComment() {
        return comment;
    }

    /**
     * setComment
     * <p>Comment inputed by staff when create/update sentence key date
     *
     * @param comment the comment to set
     */
    public void setComment(String comment) {
        this.comment = comment;
    }

    /**
     * getCalculatingDate
     * <p>The date of calculation
     *
     * @return the calculatingDate
     */
    public Date getCalculatingDate() {
        return calculatingDate;
    }

    /**
     * setCalculatingDate
     * <p>The date of calculation
     *
     * @param calculatingDate the calculatingDate to set
     */
    public void setCalculatingDate(Date calculatingDate) {
        this.calculatingDate = calculatingDate;
    }

    /**
     * getAggregateSentences
     * <p>List of aggregated sentences
     *
     * @return the aggregateSentences
     */
    public List<AggregateSentenceType> getAggregateSentences() {
        return aggregateSentences;
    }

    /**
     * setAggregateSentences
     * <p>List of aggregated sentences
     *
     * @param aggregateSentences the aggregateSentences to set
     */
    public void setAggregateSentences(List<AggregateSentenceType> aggregateSentences) {
        this.aggregateSentences = aggregateSentences;
    }

    /**
     * Controlling Aggregate
     * <p>isControlling Is Controlling Aggregated Sentence --  True: is; False: is not
     *
     * @return the isControlling
     */
    public Boolean getIsControlling() {
        return isControlling;
    }

    /**
     * Controlling Aggregate
     * <p>isControlling Is Controlling Aggregated Sentence --  True: is; False: is not
     *
     * @param isControlling the isControlling to set
     */
    public void setIsControlling(Boolean isControlling) {
        this.isControlling = isControlling;
    }

    /**
     * getSentenceKeyDateHistId
     * <p>Sentence Key Date History Id
     *
     * @return the sentenceKeyDateHistId
     */
    public Long getSentenceKeyDateHistId() {
        return sentenceKeyDateHistId;
    }

    /**
     * setSentenceKeyDateHistId
     * <p>Sentence Key Date History Id
     *
     * @param sentenceKeyDateHistId the sentenceKeyDateHistId to set
     */
    public void setSentenceKeyDateHistId(Long sentenceKeyDateHistId) {
        this.sentenceKeyDateHistId = sentenceKeyDateHistId;
    }

    /**
     * getSupervisionSentenceId
     * <p>Supervision Sentence Id of SupervisionSentenceType
     *
     * @return the supervisionSentenceId
     */
    public Long getSupervisionSentenceId() {
        return supervisionSentenceId;
    }

    /**
     * setSupervisionSentenceId
     * <p>Supervision Sentence Id of SupervisionSentenceType
     *
     * @param supervisionSentenceId the supervisionSentenceId to set
     */
    public void setSupervisionSentenceId(Long supervisionSentenceId) {
        this.supervisionSentenceId = supervisionSentenceId;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#hashCode()
     */
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((aggregateGroupId == null) ? 0 : aggregateGroupId.hashCode());
        result = prime * result + ((aggregateSentences == null) ? 0 : aggregateSentences.hashCode());
        result = prime * result + ((calculatingDate == null) ? 0 : calculatingDate.hashCode());
        result = prime * result + ((daysToServe == null) ? 0 : daysToServe.hashCode());
        result = prime * result + ((endDate == null) ? 0 : endDate.hashCode());
        result = prime * result + ((goodTime == null) ? 0 : goodTime.hashCode());
        result = prime * result + ((prdDate == null) ? 0 : prdDate.hashCode());
        result = prime * result + ((sentenceKeyDateHistId == null) ? 0 : sentenceKeyDateHistId.hashCode());
        result = prime * result + ((staffId == null) ? 0 : staffId.hashCode());
        result = prime * result + ((startDate == null) ? 0 : startDate.hashCode());
        result = prime * result + ((supervisionId == null) ? 0 : supervisionId.hashCode());
        result = prime * result + ((totalSentenceDays == null) ? 0 : totalSentenceDays.hashCode());
        return result;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
			return true;
		}
        if (obj == null) {
			return false;
		}
        if (getClass() != obj.getClass()) {
			return false;
		}
        AggregateSentenceGroupType other = (AggregateSentenceGroupType) obj;
        if (aggregateGroupId == null) {
            if (other.aggregateGroupId != null) {
				return false;
			}
        } else if (!aggregateGroupId.equals(other.aggregateGroupId)) {
			return false;
		}
        if (aggregateSentences == null) {
            if (other.aggregateSentences != null) {
				return false;
			}
        } else if (!aggregateSentences.equals(other.aggregateSentences)) {
			return false;
		}
        if (calculatingDate == null) {
            if (other.calculatingDate != null) {
				return false;
			}
        } else if (!calculatingDate.equals(other.calculatingDate)) {
			return false;
		}
        if (daysToServe == null) {
            if (other.daysToServe != null) {
				return false;
			}
        } else if (!daysToServe.equals(other.daysToServe)) {
			return false;
		}
        if (endDate == null) {
            if (other.endDate != null) {
				return false;
			}
        } else if (!endDate.equals(other.endDate)) {
			return false;
		}
        if (goodTime == null) {
            if (other.goodTime != null) {
				return false;
			}
        } else if (!goodTime.equals(other.goodTime)) {
			return false;
		}
        if (prdDate == null) {
            if (other.prdDate != null) {
				return false;
			}
        } else if (!prdDate.equals(other.prdDate)) {
			return false;
		}
        if (sentenceKeyDateHistId == null) {
            if (other.sentenceKeyDateHistId != null) {
				return false;
			}
        } else if (!sentenceKeyDateHistId.equals(other.sentenceKeyDateHistId)) {
			return false;
		}
        if (staffId == null) {
            if (other.staffId != null) {
				return false;
			}
        } else if (!staffId.equals(other.staffId)) {
			return false;
		}
        if (startDate == null) {
            if (other.startDate != null) {
				return false;
			}
        } else if (!startDate.equals(other.startDate)) {
			return false;
		}
        if (supervisionId == null) {
            if (other.supervisionId != null) {
				return false;
			}
        } else if (!supervisionId.equals(other.supervisionId)) {
			return false;
		}
        if (totalSentenceDays == null) {
            if (other.totalSentenceDays != null) {
				return false;
			}
        } else if (!totalSentenceDays.equals(other.totalSentenceDays)) {
			return false;
		}
        return true;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        return "AggregateSentenceGroupType [aggregateGroupId=" + aggregateGroupId + ", supervisionId=" + supervisionId + ", startDate=" + startDate + ", endDate="
                + endDate + ", prdDate=" + prdDate + ", totalSentenceDays=" + totalSentenceDays + ", goodTime=" + goodTime + ", daysToServe=" + daysToServe + ", staffId="
                + staffId + ", comment=" + comment + ", calculatingDate=" + calculatingDate + ", aggregateSentences=" + aggregateSentences + ", isControlling="
                + isControlling + ", sentenceKeyDateHistId=" + sentenceKeyDateHistId + ", supervisionSentenceId=" + supervisionSentenceId + "]";
    }

}
